## aboot 0.5

=== Makefile ===
#
# aboot/Makefile
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file "COPYING" in the main directory of this archive
# for more details.
#
# Copyright (c) 1995, 1996 by David Mosberger (davidm@cs.arizona.edu)
#

# location of linux kernel sources (must be absolute path):
KSRC		= /usr/src/linux
VMLINUX		= $(KSRC)/vmlinux
VMLINUXGZ	= $(KSRC)/arch/alpha/boot/vmlinux.gz

#CFGDEFS	= -DDEBUG

root		=
bindir		= $(root)/sbin
bootdir		= $(root)/boot

#
# There shouldn't be any need to change anything below this line.
#
LOADADDR	= 20000000

ifeq ($(shell uname),Linux)
 elf=$(shell if $(LD) --help | grep elf64alpha >/dev/null; then echo yes; fi)
 ifeq ($(elf),yes)
   LINKFLAGS = -static -Ttext 0xfffffc0000310000 -N
   ABOOT_LDFLAGS = -static -N -Ttext $(LOADADDR)	# for Linux/ELF
 else
   ABOOT_LDFLAGS = -static -N -Taboot.lds		# for Linux/ECOFF
 endif
else
 ABOOT_LDFLAGS	= -non_shared -N -T $(LOADADDR)	# for DEC Unix
endif

CC		= gcc
OBJSTRIP	= $(KSRC)/arch/alpha/boot/tools/objstrip
TOP		= $(shell pwd)
CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -O2 -Wall -mno-fp-regs
ASFLAGS		= $(CPPFLAGS)

.c.s:
	$(CC) $(CFLAGS) -S -o $*.s $<
.s.o:
	$(AS) -o $*.o $<
.c.o:
	$(CC) $(CFLAGS) -c -o $*.o $<
.S.s:
	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -traditional -E -o $*.o $<
.S.o:
	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -traditional -c -o $*.o $<

NET_OBJS = net.o
DISK_OBJS = disk.o fs/ext2.o fs/ufs.o fs/dummy.o fs/iso.o
ABOOT_OBJS = \
	head.o aboot.o cons.o utils.o \
	zip/misc.o zip/unzip.o zip/inflate.o
LIBS	= lib/libaboot.a

all:	diskboot

diskboot:	bootlx sdisklabel/sdisklabel sdisklabel/swriteboot \
		tools/e2writeboot tools/isomarkboot tools/abootconf \
		tools/elfencap

netboot: vmlinux.bootp

bootlx:	aboot $(OBJSTRIP)
	$(OBJSTRIP) -vb aboot bootlx

install: tools/abootconf tools/e2writeboot tools/isomarkboot \
	sdisklabel/swriteboot
	install -d -g 0 -o 0 $(bindir) $(bootdir)
	install -c -s -g 0 -o 0 tools/abootconf $(bindir)
	install -c -s -g 0 -o 0 tools/e2writeboot $(bindir)
	install -c -s -g 0 -o 0 tools/isomarkboot $(bindir)
	install -c -s -g 0 -o 0 sdisklabel/swriteboot $(bindir)
	install -c -g 0 -o 0 bootlx $(bootdir)

installondisk:	bootlx sdisklabel/swriteboot
	sdisklabel/swriteboot -vf0 /dev/sda bootlx vmlinux.gz

aboot:	$(ABOOT_OBJS) $(DISK_OBJS) $(LIBS)
	$(LD) $(ABOOT_LDFLAGS) $(ABOOT_OBJS) $(DISK_OBJS) -o $@ $(LIBS)
	strip $@ # this is needed to work around an ELF bug:

vmlinux.bootp: net_aboot.nh $(VMLINUXGZ) net_pad
	cat net_aboot.nh $(VMLINUXGZ) net_pad > $@

net_aboot.nh: net_aboot $(OBJSTRIP)
	$(OBJSTRIP) -vb net_aboot $@

net_aboot: $(ABOOT_OBJS) $(ABOOT_OBJS) $(NET_OBJS) $(LIBS)
	$(LD) $(ABOOT_LDFLAGS) $(ABOOT_OBJS) $(NET_OBJS) -o $@ $(LIBS)

net_pad:
	dd if=/dev/zero of=$@ bs=512 count=1

clean:	sdisklabel/clean tools/clean lib/clean
	rm -f aboot abootconf net_aboot net_aboot.nh net_pad vmlinux.bootp \
		$(ABOOT_OBJS) $(DISK_OBJS) $(NET_OBJS) bootlx \
		include/ksize.h vmlinux.nh

distclean: clean
	find . -name \*~ | xargs rm -f

lib/%:
	make -C lib $* CPPFLAGS="$(CPPFLAGS)"

tools/%:
	make -C tools $* CPPFLAGS="$(CPPFLAGS)"

sdisklabel/%:
	make -C sdisklabel $* CPPFLAGS="$(CPPFLAGS)"

disk.o: include/ksize.h

vmlinux.nh include/ksize.h: $(OBJSTRIP)
	cp $(VMLINUX) vmlinux.strip
	strip vmlinux.strip	# work around ELF binutils bug
	echo "#define KERNEL_SIZE `$(OBJSTRIP) -p vmlinux.strip /dev/null`" \
	 > include/ksize.h
	$(OBJSTRIP) -vb vmlinux.strip vmlinux.nh
	rm -rf vmlinux.strip

dep:

=== doc/Makefile ===
all: srm.html srm.txt srm.ps.gz

srm.html: srm.sgml
	sgml2html srm

srm.txt: srm.sgml
	sgml2txt srm
	mv srm.txt srm.ansi
	cat srm.ansi | col -b >srm.txt
	rm -f srm.ansi

srm.ps.gz: srm.sgml
	sgml2ps srm
	gzip -vf srm.ps

=== lib/Makefile ===
CC	= gcc
CPPFLAGS +=  -D__KERNEL__ -I../include
CFLAGS	= -O2 -Wall -mno-fp-regs
ASFLAGS	= $(CPPFLAGS) -D__ASSEMBLY__ -traditional

libaboot.a: libaboot.a(							\
	vsprintf.o memcpy.o memset.o string.o _setjmp.o _longjmp.o isolib.o \
	__divqu.o __remqu.o __divlu.o __remlu.o)

clean:
	rm -f libaboot.a *.o

__divqu.o: divide.S
	$(CC) -DDIV -c -o $@ divide.S

__remqu.o: divide.S
	$(CC) -DREM -c -o $@ divide.S

__divlu.o: divide.S
	$(CC) -DDIV -DINTSIZE -c -o $@ divide.S

__remlu.o: divide.S
	$(CC) -DREM -DINTSIZE -c -o $@ divide.S

=== tools/Makefile ===
CC	= gcc
CFLAGS	= -g -O2 -Wall -I. -I../include $(CPPFLAGS)
LDFLAGS	= -g
PGMS	= e2writeboot isomarkboot abootconf elfencap

EXEC_PREFIX = /usr

all:	$(PGMS)

install:	$(PGMS)
	install -s -c -o root -g root -m 755 $(PGMS) $(EXEC_PREFIX)/bin

clean:
	rm -f *~ *.o *.a core $(PGMS)

isomarkboot:	isomarkboot.o ../lib/isolib.o
e2writeboot:	e2writeboot.o e2lib.o bio.o

e2writeboot.o:	e2lib.h
e2lib.o: e2lib.h

## aboot 0.7

=== Makefile ===
#
# aboot/Makefile
#
# This file is subject to the terms and conditions of the GNU General Public
# License.  See the file "COPYING" in the main directory of this archive
# for more details.
#
# Copyright (c) 1995, 1996 by David Mosberger (davidm@cs.arizona.edu)
#

# location of linux kernel sources (must be absolute path):
KSRC		= /usr/src/linux
VMLINUX		= $(KSRC)/vmlinux
VMLINUXGZ	= $(KSRC)/arch/alpha/boot/vmlinux.gz

# for userspace testing
# TESTING	= yes

# for boot testing
# CFGDEFS	= -DDEBUG

root		=
bindir		= $(root)/sbin
bootdir		= $(root)/boot

#
# There shouldn't be any need to change anything below this line.
#
LOADADDR	= 20000000

ABOOT_LDFLAGS = -static -N -Taboot.lds

CC		= gcc
TOP		= $(shell pwd)
ifeq ($(TESTING),)
CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -mcpu=ev4 -Os -Wall -mno-fp-regs -ffixed-8
else
CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include
CFLAGS		= $(CPPFLAGS) -O -g3 -Wall -D__KERNEL__ -ffixed-8
endif
ASFLAGS		= $(CPPFLAGS)


.c.s:
	$(CC) $(CFLAGS) -S -o $*.s $<
.s.o:
	$(AS) -o $*.o $<
.c.o:
	$(CC) $(CFLAGS) -c -o $*.o $<
.S.s:
	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -traditional -E -o $*.o $<
.S.o:
	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -traditional -c -o $*.o $<

NET_OBJS = net.o
DISK_OBJS = disk.o fs/ext2.o fs/ufs.o fs/dummy.o fs/iso.o
ifeq ($(TESTING),)
ABOOT_OBJS = \
	head.o aboot.o cons.o utils.o \
	zip/misc.o zip/unzip.o zip/inflate.o
else
ABOOT_OBJS = aboot.o zip/misc.o zip/unzip.o zip/inflate.o
endif
LIBS	= lib/libaboot.a

ifeq ($(TESTING),)
all:	diskboot
else
all:	aboot
endif

diskboot:	bootlx sdisklabel/sdisklabel sdisklabel/swriteboot \
		tools/e2writeboot tools/isomarkboot tools/abootconf \
		tools/elfencap

netboot: vmlinux.bootp

bootlx:	aboot tools/objstrip
	tools/objstrip -vb aboot bootlx

install: tools/abootconf tools/e2writeboot tools/isomarkboot \
	sdisklabel/swriteboot
	install -d $(bindir) $(bootdir)
	install -c -s tools/abootconf $(bindir)
	install -c -s tools/e2writeboot $(bindir)
	install -c -s tools/isomarkboot $(bindir)
	install -c -s sdisklabel/swriteboot $(bindir)
	install -c bootlx $(bootdir)

installondisk:	bootlx sdisklabel/swriteboot
	sdisklabel/swriteboot -vf0 /dev/sda bootlx vmlinux.gz

ifeq ($(TESTING),)
aboot:	$(ABOOT_OBJS) $(DISK_OBJS) $(LIBS)
	$(LD) $(ABOOT_LDFLAGS) $(ABOOT_OBJS) $(DISK_OBJS) -o $@ $(LIBS)
else
aboot:	$(ABOOT_OBJS) $(DISK_OBJS) $(LIBS)
	$(CC) $(ABOOT_OBJS) $(DISK_OBJS) -o $@ $(LIBS)
endif

vmlinux.bootp: net_aboot.nh $(VMLINUXGZ) net_pad
	cat net_aboot.nh $(VMLINUXGZ) net_pad > $@

net_aboot.nh: net_aboot tools/objstrip
	tools/objstrip -vb net_aboot $@

net_aboot: $(ABOOT_OBJS) $(ABOOT_OBJS) $(NET_OBJS) $(LIBS)
	$(LD) $(ABOOT_LDFLAGS) $(ABOOT_OBJS) $(NET_OBJS) -o $@ $(LIBS)

net_pad:
	dd if=/dev/zero of=$@ bs=512 count=1

clean:	sdisklabel/clean tools/clean lib/clean
	rm -f aboot abootconf net_aboot net_aboot.nh net_pad vmlinux.bootp \
		$(ABOOT_OBJS) $(DISK_OBJS) $(NET_OBJS) bootlx \
		include/ksize.h vmlinux.nh

distclean: clean
	find . -name \*~ | xargs rm -f

lib/%:
	make -C lib $* CPPFLAGS="$(CPPFLAGS)" TESTING="$(TESTING)"

tools/%:
	make -C tools $* CPPFLAGS="$(CPPFLAGS)"

sdisklabel/%:
	make -C sdisklabel $* CPPFLAGS="$(CPPFLAGS)"

vmlinux.nh: $(VMLINUX) tools/objstrip
	tools/objstrip -vb $(VMLINUX) vmlinux.nh

include/ksize.h: vmlinux.nh
	echo "#define KERNEL_SIZE `ls -l vmlinux.nh | awk '{print $$5}'` > $@

dep:

=== doc/Makefile ===
all: SRM-HOWTO.html SRM-HOWTO.txt SRM-HOWTO.ps.gz SRM-HOWTO.pdf

%.html: %.sgml
	sgml2html $<

%.txt: %.sgml
	sgml2txt $<
	mv $@ $@.ansi.tmp
	cat $@.ansi.tmp | col -b > $@
	rm -f $@.ansi.tmp

%.tex: %.sgml
	sgml2latex $<

%.ps.gz: %.tex
	latex $<
	latex $<
	dvips -o $(patsubst %.tex,%.ps,$<) $(patsubst %.tex,%.dvi,$<)
	gzip  -f $(patsubst %.tex,%.ps,$<)
	rm -f $*.{dvi,aux,log,toc}

%.pdf: %.tex
	pdflatex $<
	pdflatex $<
	rm -f $*.{dvi,aux,log,toc}

=== lib/Makefile ===
CC	= gcc
CPPFLAGS +=  -D__KERNEL__ -I../include
ifeq ($(TESTING),)
CFLAGS	= -O -Wall -mno-fp-regs
else
CFLAGS  = -O -g3 -Wall
endif
ASFLAGS	= $(CPPFLAGS) -D__ASSEMBLY__ -traditional

ifeq ($(TESTING),)
libaboot.a: vsprintf.o memcpy.o memset.o string.o _setjmp.o \
	_longjmp.o isolib.o __divqu.o __remqu.o __divlu.o \
	__remlu.o
	ar cru $@ $?
else
libaboot.a: isolib.o
	ar cru $@ $?
endif

clean:
	rm -f libaboot.a *.o

__divqu.o: divide.S
	$(CC) -DDIV -c -o $@ divide.S

__remqu.o: divide.S
	$(CC) -DREM -c -o $@ divide.S

__divlu.o: divide.S
	$(CC) -DDIV -DINTSIZE -c -o $@ divide.S

__remlu.o: divide.S
	$(CC) -DREM -DINTSIZE -c -o $@ divide.S

## aboot 0.9

=== Makefile ===
--- 
+++ 
@@ -14,14 +14,16 @@
 VMLINUXGZ	= $(KSRC)/arch/alpha/boot/vmlinux.gz
 
 # for userspace testing
-# TESTING	= yes
+#TESTING	= yes
 
 # for boot testing
-# CFGDEFS	= -DDEBUG
+#CFGDEFS       	= -DDEBUG_ISO -DDEBUG_ROCK -DDEBUG
 
+# root, aka prefix
 root		=
 bindir		= $(root)/sbin
 bootdir		= $(root)/boot
+mandir		= /usr/man
 
 #
 # There shouldn't be any need to change anything below this line.
@@ -34,9 +36,9 @@
 TOP		= $(shell pwd)
 ifeq ($(TESTING),)
 CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
-CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -mcpu=ev4 -Os -Wall -mno-fp-regs -ffixed-8
+CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -mcpu=ev4 -Os -Wall -Wcast-align -mno-fp-regs -ffixed-8
 else
-CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include
+CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
 CFLAGS		= $(CPPFLAGS) -O -g3 -Wall -D__KERNEL__ -ffixed-8
 endif
 ASFLAGS		= $(CPPFLAGS)
@@ -79,8 +81,14 @@
 bootlx:	aboot tools/objstrip
 	tools/objstrip -vb aboot bootlx
 
+install-man: 
+	make -C doc/man install
+
+install-man-gz:
+	make -C doc/man install-gz
+
 install: tools/abootconf tools/e2writeboot tools/isomarkboot \
-	sdisklabel/swriteboot
+	sdisklabel/swriteboot install-man
 	install -d $(bindir) $(bootdir)
 	install -c -s tools/abootconf $(bindir)
 	install -c -s tools/e2writeboot $(bindir)

=== lib/Makefile ===
--- 
+++ 
@@ -1,9 +1,9 @@
 CC	= gcc
 CPPFLAGS +=  -D__KERNEL__ -I../include
 ifeq ($(TESTING),)
-CFLAGS	= -O -Wall -mno-fp-regs
+CFLAGS	= -Os -Wall -mno-fp-regs
 else
-CFLAGS  = -O -g3 -Wall
+CFLAGS  = -Os -g3 -Wall
 endif
 ASFLAGS	= $(CPPFLAGS) -D__ASSEMBLY__ -traditional

## aboot 0.9b

=== Makefile ===
--- 
+++ 
@@ -36,7 +36,7 @@
 TOP		= $(shell pwd)
 ifeq ($(TESTING),)
 CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
-CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -mcpu=ev4 -Os -Wall -Wcast-align -mno-fp-regs -ffixed-8
+CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -mcpu=ev4 -Os -Wall -fno-builtin -mno-fp-regs -ffixed-8
 else
 CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
 CFLAGS		= $(CPPFLAGS) -O -g3 -Wall -D__KERNEL__ -ffixed-8

## aboot 1.0~pre20040408

=== Makefile ===
--- 
+++ 
@@ -17,13 +17,15 @@
 #TESTING	= yes
 
 # for boot testing
-#CFGDEFS       	= -DDEBUG_ISO -DDEBUG_ROCK -DDEBUG
+#CFGDEFS       	= -DDEBUG_ISO -DDEBUG_ROCK -DDEBUG_EXT2 -DDEBUG
 
 # root, aka prefix
 root		=
 bindir		= $(root)/sbin
 bootdir		= $(root)/boot
-mandir		= /usr/man
+mandir         = $(root)/usr/share/man
+
+export
 
 #
 # There shouldn't be any need to change anything below this line.
@@ -35,10 +37,10 @@
 CC		= gcc
 TOP		= $(shell pwd)
 ifeq ($(TESTING),)
-CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
-CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -mcpu=ev4 -Os -Wall -fno-builtin -mno-fp-regs -ffixed-8
+CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include
+CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -Os -Wall -fno-builtin -mno-fp-regs -ffixed-8
 else
-CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include -I$(KSRC)/include
+CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include
 CFLAGS		= $(CPPFLAGS) -O -g3 -Wall -D__KERNEL__ -ffixed-8
 endif
 ASFLAGS		= $(CPPFLAGS)

=== lib/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CC	= gcc
 CPPFLAGS +=  -D__KERNEL__ -I../include
 ifeq ($(TESTING),)
-CFLAGS	= -Os -Wall -mno-fp-regs
+CFLAGS	= -Os -Wall -mno-fp-regs -fno-builtin
 else
 CFLAGS  = -Os -g3 -Wall
 endif

=== sdisklabel/Makefile ===
CC = gcc -O2
CFLAGS= -I../include $(CPPFLAGS) -Wall

all:	sdisklabel swriteboot

sdisklabel: sdisklabel.o library.o
	$(CC) $(LDFLAGS) sdisklabel.o library.o -o sdisklabel

swriteboot: swriteboot.o library.o
	$(CC) $(LDFLAGS) swriteboot.o library.o -o swriteboot

clean:
	rm -f sdisklabel swriteboot *.o

=== tools/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 CC	= gcc
 CFLAGS	= -g -O2 -Wall -I. -I../include $(CPPFLAGS)
 LDFLAGS	= -g
-PGMS	= e2writeboot isomarkboot abootconf elfencap
+PGMS	= e2writeboot isomarkboot abootconf elfencap objstrip
 
 EXEC_PREFIX = /usr

=== doc/faq/Makefile ===
all-html : SRM-HOWTO/index.html

clean :
	rm -rf SRM-HOWTO 

SRM-HOWTO/index.html : SRM-HOWTO.sgml
	            sgmltools --backend=html SRM-HOWTO.sgml

=== doc/man/Makefile ===
# eventually this should have rules for recreating the man pages from the 
# sgml source, but since this doesn't work on my machine right now i'm
# leaving it out.

# if this is a recursive make, and mandir was set in the top-level Makefile,
# use that value. Otherwise default to /usr/man.

ifeq ($(mandir),)
MANDIR=/usr/man
else
MANDIR=$(mandir)
endif
MAN5=$(MANDIR)/man5
MAN8=$(MANDIR)/man8

default: 

install: 
	install -d $(MAN5) $(MAN8)
	install -c aboot.conf.5 $(MAN5)
	install -c aboot.8 abootconf.8 e2writeboot.8 swriteboot.8 $(MAN8)	
install-gz: install
	gzip -f9 $(MAN5)/aboot.conf.5
	gzip -f9 $(MAN8)/aboot.8 $(MAN8)/abootconf.8 $(MAN8)/e2writeboot.8 \
		 $(MAN8)/swriteboot.8
install-gzip: install-gz

## aboot 1.0~pre20200212

=== Makefile ===
--- 
+++ 
@@ -32,18 +32,17 @@
 #
 LOADADDR	= 20000000
 
-ABOOT_LDFLAGS = -static -N -Taboot.lds
+ABOOT_LDFLAGS = -static -N -Taboot.lds --relax
 
-CC		= gcc
-TOP		= $(shell pwd)
 ifeq ($(TESTING),)
-CPPFLAGS	= $(CFGDEFS) -I$(TOP)/include
-CFLAGS		= $(CPPFLAGS) -D__KERNEL__ -Os -Wall -fno-builtin -mno-fp-regs -ffixed-8
+override CPPFLAGS	+= $(CFGDEFS) -U_FORTIFY_SOURCE -Iinclude
+override CFLAGS		+= $(CPPFLAGS) -Os -Wall -ffreestanding -mno-fp-regs -msmall-data -msmall-text
 else
-CPPFLAGS	= -DTESTING $(CFGDEFS) -I$(TOP)/include
-CFLAGS		= $(CPPFLAGS) -O -g3 -Wall -D__KERNEL__ -ffixed-8
+override CPPFLAGS	+= -DTESTING $(CFGDEFS) -U_FORTIFY_SOURCE -Iinclude
+override CFLAGS		+= $(CPPFLAGS) -O -g3 -Wall
 endif
-ASFLAGS		= $(CPPFLAGS)
+
+override ASFLAGS	+= $(CPPFLAGS)
 
 
 .c.s:
@@ -53,9 +52,9 @@
 .c.o:
 	$(CC) $(CFLAGS) -c -o $*.o $<
 .S.s:
-	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -traditional -E -o $*.o $<
+	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -E -o $*.o $<
 .S.o:
-	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -traditional -c -o $*.o $<
+	$(CC) $(ASFLAGS) -D__ASSEMBLY__ -c -o $*.o $<
 
 NET_OBJS = net.o
 DISK_OBJS = disk.o fs/ext2.o fs/ufs.o fs/dummy.o fs/iso.o
@@ -80,6 +79,13 @@
 
 netboot: vmlinux.bootp
 
+bootloader.h: net_aboot.nh b2c
+	./b2c net_aboot.nh bootloader.h bootloader
+
+netabootwrap: netabootwrap.c bootloader.h
+	$(CC) $@.c $(CFLAGS) -o $@
+
+
 bootlx:	aboot tools/objstrip
 	tools/objstrip -vb aboot bootlx
 
@@ -92,10 +98,10 @@
 install: tools/abootconf tools/e2writeboot tools/isomarkboot \
 	sdisklabel/swriteboot install-man
 	install -d $(bindir) $(bootdir)
-	install -c -s tools/abootconf $(bindir)
-	install -c -s tools/e2writeboot $(bindir)
-	install -c -s tools/isomarkboot $(bindir)
-	install -c -s sdisklabel/swriteboot $(bindir)
+	install -c tools/abootconf $(bindir)
+	install -c tools/e2writeboot $(bindir)
+	install -c tools/isomarkboot $(bindir)
+	install -c sdisklabel/swriteboot $(bindir)
 	install -c bootlx $(bootdir)
 
 installondisk:	bootlx sdisklabel/swriteboot
@@ -113,6 +119,7 @@
 	cat net_aboot.nh $(VMLINUXGZ) net_pad > $@
 
 net_aboot.nh: net_aboot tools/objstrip
+	strip net_aboot
 	tools/objstrip -vb net_aboot $@
 
 net_aboot: $(ABOOT_OBJS) $(ABOOT_OBJS) $(NET_OBJS) $(LIBS)
@@ -124,7 +131,7 @@
 clean:	sdisklabel/clean tools/clean lib/clean
 	rm -f aboot abootconf net_aboot net_aboot.nh net_pad vmlinux.bootp \
 		$(ABOOT_OBJS) $(DISK_OBJS) $(NET_OBJS) bootlx \
-		include/ksize.h vmlinux.nh
+		include/ksize.h vmlinux.nh b2c bootloader.h netabootwrap
 
 distclean: clean
 	find . -name \*~ | xargs rm -f

=== lib/Makefile ===
--- 
+++ 
@@ -1,11 +1,15 @@
-CC	= gcc
-CPPFLAGS +=  -D__KERNEL__ -I../include
+override CPPFLAGS += -U_FORTIFY_SOURCE -I../include
+override ASFLAGS += $(CPPFLAGS) -D__ASSEMBLY__
+
 ifeq ($(TESTING),)
-CFLAGS	= -Os -Wall -mno-fp-regs -fno-builtin
+ifeq ($(FOREIGN),"yes")
+override CFLAGS	+= -Os -Wall -ffreestanding
 else
-CFLAGS  = -Os -g3 -Wall
+override CFLAGS += -Os -Wall -mno-fp-regs -ffreestanding
 endif
-ASFLAGS	= $(CPPFLAGS) -D__ASSEMBLY__ -traditional
+else
+override CFLAGS += -Os -g3 -Wall
+endif
 
 ifeq ($(TESTING),)
 libaboot.a: vsprintf.o memcpy.o memset.o string.o _setjmp.o \

=== sdisklabel/Makefile ===
override CFLAGS += -g -O2 -I../include -Wall $(CPPFLAGS)

all:	sdisklabel swriteboot

sdisklabel: sdisklabel.o library.o
	$(CC) $(LDFLAGS) $(CFLAGS) sdisklabel.o library.o -o sdisklabel

swriteboot: swriteboot.o library.o
	$(CC) $(LDFLAGS) $(CFLAGS) swriteboot.o library.o -o swriteboot

clean:
	rm -f sdisklabel swriteboot *.o

=== srmbootfat/Makefile ===
override CFLAGS	+= -O2 -g -pipe -Wall
#override LDFLAGS	+= -s
SBINDIR	= ../bin

all:	srmbootfat srmbootraw srmbootfat.1 srmbootraw.8

srmbootfat: srmbootfat.c msdos.h
	$(CC) $(CFLAGS) $(LDFLAGS) -o srmbootfat srmbootfat.c

srmbootraw: srmbootraw.c
	$(CC) $(CFLAGS) $(LDFLAGS) -o srmbootraw srmbootraw.c

%.1: %.sgml
	docbook2man -d sgmlspl-specs/docbook2man-spec.pl $<

%.8: %.sgml
	docbook2man -d sgmlspl-specs/docbook2man-spec.pl $<

clean:
	rm -f srmbootfat srmbootraw srmbootfat.1 srmbootraw.8 manpage.links manpage.log manpage.refs

=== tools/Makefile ===
override CFLAGS += -g -O2 -Wall -I. -I../include $(CPPFLAGS)
override PGMS += e2writeboot isomarkboot abootconf elfencap objstrip

EXEC_PREFIX = /usr

all:	$(PGMS)

install:	$(PGMS)
	install -c -o root -g root -m 755 $(PGMS) $(EXEC_PREFIX)/bin

clean:
	rm -f *~ *.o *.a core $(PGMS)

isomarkboot:	isomarkboot.o ../lib/isolib.o
e2writeboot:	e2writeboot.o e2lib.o bio.o

e2writeboot.o:	e2lib.h
e2lib.o: e2lib.h

=== doc/faq/Makefile ===
all-html: SRM-HOWTO/index.html

clean:
	rm -rf SRM-HOWTO

SRM-HOWTO/index.html : SRM-HOWTO.sgml
	docbook2html SRM-HOWTO.sgml -o SRM-HOWTO

=== doc/man/Makefile ===
--- 
+++ 
@@ -10,17 +10,34 @@
 else
 MANDIR=$(mandir)
 endif
+MAN1=$(MANDIR)/man1
 MAN5=$(MANDIR)/man5
 MAN8=$(MANDIR)/man8
 
-default: 
+all: aboot.8 aboot.conf.5 abootconf.8 isomarkboot.1 sdisklabel.8 netabootwrap.1
 
-install: 
-	install -d $(MAN5) $(MAN8)
+install:
+	install -d $(MAN1) $(MAN5) $(MAN8)
+	install -c isomarkboot.1 netabootwrap.1 $(MAN1)
 	install -c aboot.conf.5 $(MAN5)
-	install -c aboot.8 abootconf.8 e2writeboot.8 swriteboot.8 $(MAN8)	
+	install -c aboot.8 abootconf.8 e2writeboot.8 swriteboot.8 sdisklabel.8 $(MAN8)
+
 install-gz: install
+	gzip -f9 $(MAN1)/isomarkboot.1 $(MAN1)/netabootwrap.1
 	gzip -f9 $(MAN5)/aboot.conf.5
 	gzip -f9 $(MAN8)/aboot.8 $(MAN8)/abootconf.8 $(MAN8)/e2writeboot.8 \
-		 $(MAN8)/swriteboot.8
+		 $(MAN8)/swriteboot.8 $(MAN8)/sdisklabel.8
+
 install-gzip: install-gz
+
+clean:
+	rm -f aboot.8 aboot.conf.5 abootconf.8 isomarkboot.1 sdisklabel.8 netabootwrap.1 manpage.log manpage.links manpage.refs
+
+%.1: %.sgml
+	docbook2man $<
+
+%.5: %.sgml
+	docbook2man $<
+
+%.8: %.sgml
+	docbook2man $<

=== doc/man/de/Makefile ===
all: aboot.8 aboot.conf.5 abootconf.8 isomarkboot.1 netabootwrap.1 srmbootfat.1 srmbootraw.8 sdisklabel.8

clean:
	rm -f *.html aboot.8 aboot.conf.5 abootconf.8 isomarkboot.1 netabootwrap.1 srmbootfat.1 srmbootraw.8 sdisklabel.8 manpage.links manpage.log manpage.refs

%.1: %.sgml
	docbook2man -d docbook2man-de-spec.pl $<

%.5: %.sgml
	docbook2man -d docbook2man-de-spec.pl $<

%.8: %.sgml
	docbook2man -d docbook2man-de-spec.pl $<

#.PHONY clean

=== debian/changelog ===
aboot (1.0~pre20200212-1) unstable; urgency=medium

  * New upstream version
  * Set myself as maintainer in debian/control (Closes: #950591)
  * Add libext2fs-dev to Build-Depends for alpha in debian/control
  * Drop sgmlspl from Build-Depends in debian/control
  * Drop sp from Build-Depends in debian/control (Closes: #832491)
  * Drop sgmltools-lite from Build-Depends-Indep in debian/control (Closes: #949711)
  * Use rename to adjust filenames for German manpages
    - Add rename to Build-Depends in debian/control
    - Run rename to adjust German manpage filenames in debian/rules
  * Switch package to source format 3.0 (quilt)
  * Update Vcs-* fields for new Salsa project in debian/control

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Sat, 07 Mar 2020 12:12:47 +0100

aboot (1.0~pre20040408-4) unstable; urgency=low

  * Add Vcs-Bzr field to debian/control.
  * Add headers needed for size_t and other types with recent
    linux-libc-dev.
  * Pull in include/linux/ext2_fs.h from the Linux 3.2.46 source, since it's
    no longer included in linux-libc-dev and recent versions are much less
    userspace-friendly.
  * fs/ufs.c, include/ufs.h: replace undefined types with the modern kernel
    types.
  * tools/objstrip.c: fix elf structure definitions.
  * tools/isomarkboot.c: avoid mixing kernel and libc headers.
    Closes: #652598.
  * Correct accidental revert of upstream sources in 1.0~pre20040408.
    Closes: #524916.
  * Replace mkisofs with genisoimage in Suggests.  Closes: #601260.
  * Fix debian/control to use ${misc:Depends} everywhere.  Thanks to
    Benjamin Kerensa <bkerensa@ubuntu.com> for the patch.  Closes: #692636.
  * Update debian/copyright to copyright-format 1.0.
  * Modernize debian/rules: debhelper 9, dh(1).
  * Add rough support for cross-building.
  * Split sgmtools-lite into Build-Depends-Indep.
  * Use Breaks/Replaces instead of Conflicts for historical replaces.
  * Fix the doc-base section.
  * Bump to Standards-Version 3.9.3; no changes required.

 -- Steve Langasek <vorlon@debian.org>  Sun, 06 Oct 2013 23:35:32 -0700

aboot (1.0~pre20040408-3) unstable; urgency=low

  [ Helge Kreutzmann ]
  * Fix wrong sync from alioth for aboot.conf.(sgml|5), e2writeboot.8,
    swriteboot.8
  * debian/control: Move section to admin to match overrides
  * Remove incorrect isomarkboot.8 (as upstream did), this is in section 1
  * Update my e-mail address also in every man page (where applicable)
  * Slightly improve debian/rules
  * Add a note for people intending to recompile aboot on stable (Etch)
  * Update TODO
  * Update download location of milo in appropriate READMEs 
  * Bump standards version to 3.7.3.0 (no changes required)

  [ Steve Langasek ]
  * Drop the reference to asm/page.h from zip/main.c since it isn't actually
    needed, fixing a build failure with current linux-libc-dev; thanks to
    Philipp Benner <pbenner@uni-osnabrueck.de> for pointing out the obvious
    fix.  Closes: #480364.
  * disk.c: drop reference to asm/elf.h.
  * tools/objstrip.c: drop reference to asm/elf.h; use a.out.h instead
    of linux/a.out.h, which is no longer provided by the kernel; and
    include a copy of the elf_check_arch() define from the old asm/elf.h
    in the event that we're building against recent kernel headers.
  * tools/elfencap.c: there is only one right answer for each of ELF_CLASS,
    ELF_DATA, and ELF_ARCH; reference these values directly, for
    compatibility with linux-libc-dev 2.6.24 and above.
  * Take over from Helge as maintainer; thanks for all your work!
    Closes: #315592.

 -- Steve Langasek <vorlon@debian.org>  Mon, 02 Jun 2008 09:33:19 -0700

aboot (1.0~pre20040408-2) unstable; urgency=low

  * Include userspace headers from lib/isolib.c instead of kernel
    headers; this isn't kernel code anyway, and the kernel headers don't
    work right on i386 the way they're being used.

 -- Steve Langasek <vorlon@debian.org>  Wed, 22 Aug 2007 20:29:59 -0700

aboot (1.0~pre20040408-1) unstable; urgency=low

  [ Steve Langasek ]
  * New upstream version, pulled from CVS snapshot.
  * Drop separate faq-src directory, now merged upstream as doc/faq
  * Fix header references in multiple files, and import a local copy of
    asm-alpha/pal.h and asm-alpha/system.h from the kernel sources for
    use by head.S and aboot.c, for the switch to linux-libc-dev in
    lenny.  Closes: #437296.
  * Update debian/rules to use DEB_HOST_GNU_CPU instead of
    DEB_HOST_GNU_TYPE, to fix a misbuild in unstable.
  * Fix wrong manpage section for srmbootraw(8) in the clean target
  * Update bootlx to ignore ELF header sections not of type PT_LOAD when
    loading the kernel, so that the new PT_NOTE sections in 2.6.23rc1 and
    above don't cause load failures.  Thanks to Richard Henderson for the
    patch.  Closes: #438431.
  * Drop unneeded build-dependency on linux-kernel-headers, which is
    build-essential.

  [ Helge Kreutzmann ]
  * Fix minor typos in German man pages.
  * Update my e-mail address in debian related files
  * Do not ignore errors in clean targets (thanks, lintian)
  * Bump standards version to 3.7.2.2
  * Bump dephelper level to 5

 -- Steve Langasek <vorlon@debian.org>  Wed, 22 Aug 2007 14:31:26 -0700

aboot (0.9b-3) unstable; urgency=low

  * Synced man pages with upstream: aboot.conf.sgml, aboot.sgml,
    abootconf.sgml, e2writeboot.8, isomarkboot.sgml, sdisklabel.sgml,
    swriteboot.8.
  * Took german translation of man pages from upstream.
  * Minor code issues synced from upstream CVS (partially for testing
    builds). Closes: #258594.
  * Include patch to make isomarkboot endian-safe. Thanks to Steve McIntyre,
    Closes: #253846.
  * Add netabootwrap man page (english and german).
  * Fix netabootwrap so that it stops claiming to be bootp.

 -- Helge Kreutzmann <kreutzm@zola.itp.uni-hannover.de>  Mon, 12 Jul 2004 17:02:10 +0200

aboot (0.9b-2) unstable; urgency=low



=== debian/control ===
Source: aboot
Build-Depends: debhelper (>= 9), docbook-utils, libext2fs-dev [alpha], rename
Section: admin
Priority: standard
Maintainer: John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>
Standards-Version: 3.9.3
Vcs-Browser: https://salsa.debian.org/debian/aboot
Vcs-Git: https://salsa.debian.org/debian/aboot.git

Package: aboot
Architecture: alpha
Depends: ${shlibs:Depends}, ${misc:Depends}, aboot-base
Conflicts: aboot-cross
Description: Linux bootloader for the SRM console
 This is the standard Linux bootloader for machines with SRM firmware
 installed.  If you're using ARC or AlphaBIOS, you have to use MILO
 instead.
 .
 Aboot allows booting from hard disk, CD-ROM, and floppy.  It also
 provides what you need to make kernel images that can be booted over
 a network using BOOTP/TFTP.

Package: aboot-cross
Architecture: any
Priority: optional
Depends: ${shlibs:Depends}, ${misc:Depends}, aboot-base
Breaks: aboot (<< 0.9-1.2)
Replaces: aboot (<< 0.9-1.2)
Suggests: genisoimage
Description: utility to create bootable ISO-Images for Linux/Alpha
 If you want to create bootable CD-ROMs or floppies for the Linux/Alpha
 platform, you need this utility. It is not needed for normal system
 installation or operation.

Package: aboot-base
Priority: optional
Architecture: all
Depends: ${misc:Depends}
Conflicts: aboot (<< 0.9-1.2)
Description: base files required for bootable media on Linux/Alpha
 This package contains the files to create bootable media for Linux/Alpha.
 No binaries are included to enable any architecture to use these files.
 .
 Also a current version of the SRM-FAQ is included.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_GNU_CPU  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

export DEB_CPPFLAGS_MAINT_APPEND = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64
export DEB_CFLAGS_MAINT_APPEND = -Wall

CC ?= gcc
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
	CC = $(DEB_HOST_GNU_TYPE)-$(CC)
endif

ifeq (alpha,$(DEB_HOST_GNU_CPU))
	export DH_OPTIONS=-Naboot-cross
else
	export DH_OPTIONS=-paboot-cross
endif

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
      LDFLAGS += +s
#     TESTING = "TESTING=yes"
      CPPFLAGS += "-O0"
endif

%:
	dh $@

override_dh_auto_build:
ifeq (alpha,$(DEB_HOST_GNU_CPU))
	$(MAKE) $(TESTING) all netabootwrap CC=$(CC) $(shell dpkg-buildflags --export=configure)
	$(MAKE) -C doc/man all
	$(MAKE) -C doc/man/de all
	$(MAKE) -C srmbootfat all CC=$(CC) $(shell dpkg-buildflags --export=configure)
ifneq (,$(filter aboot-base, $(shell dh_listpackages)))
	$(MAKE) $(TESTING) bootlx net_aboot.nh net_pad CC=$(CC) $(shell dpkg-buildflags --export=configure)
	$(MAKE) -C doc/faq
endif
else
	$(MAKE) -C tools $(TESTING) isomarkboot CC=$(CC) $(shell dpkg-buildflags --export=configure)
	$(MAKE) -C srmbootfat srmbootfat srmbootfat.1 CC=$(CC) $(shell dpkg-buildflags --export=configure)
	$(MAKE) -C doc/man
	$(MAKE) -C doc/man/de
	rename 's/([a-z]*).([1,5,8])/\1.de.\2/' doc/man/de/*.[1,5,8]
endif

override_dh_auto_clean:
	$(MAKE) distclean
	$(MAKE) -C doc/man clean
	$(MAKE) -C doc/man/de clean
	$(MAKE) -C doc/faq clean
	$(MAKE) -C srmbootfat clean

override_dh_auto_install:
ifeq (alpha,$(DEB_HOST_GNU_CPU))
ifneq (,$(filter aboot, $(shell dh_listpackages)))
	$(MAKE) root=`pwd`/debian/aboot install
	install -m 644 aboot.conf debian/aboot/usr/share/aboot/aboot.conf
	mv debian/aboot/sbin/isomarkboot debian/aboot/usr/bin/
	install -m 755 sdisklabel/sdisklabel debian/aboot/sbin/sdisklabel
	install -m 755 srmbootfat/srmbootraw debian/aboot/sbin/srmbootraw
	install -m 755 srmbootfat/srmbootfat debian/aboot/usr/bin/
	install -m 755 netabootwrap debian/aboot/usr/bin/
	rm -rf debian/aboot/boot
	rm -rf debian/aboot/usr/share/man/man1
endif
else
	install -m 755 tools/isomarkboot debian/aboot-cross/usr/bin
	install -m 755 srmbootfat/srmbootfat debian/aboot-cross/usr/bin
endif
ifneq (,$(filter aboot-base, $(shell dh_listpackages)))
	install -m 644 bootlx debian/aboot-base/boot/bootlx
	install -m 644 net_aboot.nh debian/aboot-base/boot/
	install -m 644 net_pad debian/aboot-base/boot/
endif
